/**************************************************************** 
 * 代码作者: Alex Li
 * 创建时间: 2024-08-19 21:40:01
 * 最后修改: 2025-01-12 15:37:28
 * 文件描述: B2862  图的遍历
****************************************************************/
#include <bits/stdc++.h>
using namespace std;

// 深度优先搜索
void dfs(vector<vector<int>>& adjList, vector<bool>& visited, int now, int& maxNode) {
    for (int neighbor : adjList[now]) { // 遍历当前节点的所有邻居
        if (!visited[neighbor]) { // 如果邻居未访问
            visited[neighbor] = true; // 标记为已访问
            dfs(adjList, visited, neighbor, maxNode); // 递归访问邻居
        }
    }
    maxNode = max(maxNode, now); // 回溯时更新最大编号点
}

int main() {
	int n,t;
    cin >> n >> t; // 输入点数和边数
    vector<vector<int>> adjList(n + 1); // 邻接表存储图
    vector<bool> visited(n + 1, false); // 访问标记数组

    // 输入边
    for (int i = 1; i <= t; i++) {
        int u, v;
        cin >> u >> v;
        adjList[u].push_back(v); // 有向边 u -> v
    }

    // 遍历每个起始点，计算其能到达的最大编号点
    for (int i = 1; i <= n; i++) {
        int maxNode = i; // 从当前点出发，初始化最大点为自己
        visited.assign(n + 1, false); // 重置访问标记
        visited[i] = true; // 起始点标记为已访问
        dfs(adjList, visited, i, maxNode); // 执行 DFS
        cout << maxNode << ' '; // 输出结果
    }
    cout << endl;

    return 0;
}
